<script setup lang="ts">
    import { isDefined } from '@/shared/helpers/types'

    interface Props {
        icon:
            | 'mdi-pencil-outline'
            | 'mdi-trash-can-outline'
            | 'mdi-tune'
            | 'mdi-list-box-outline'
            | 'mdi-content-save'
            | 'mdi-paperclip'
            | 'mdi-content-duplicate'
            | 'mdi-ghost-outline'
        label: string
        numberOfItems?: number
    }

    defineProps<Props>()
</script>

<template>
    <v-btn
        v-if="$vuetify.display.mdAndUp"
        color="on-background"
        :prepend-icon="icon"
        v-bind="$attrs"
    >
        <slot>
            {{ label }}
            <v-badge
                v-if="isDefined(numberOfItems) && numberOfItems !== 0"
                color="primary"
                class="ml-auto"
                :content="numberOfItems"
                inline
            >
            </v-badge>
        </slot>
    </v-btn>
    <template v-else>
        <v-badge
            v-if="isDefined(numberOfItems) && numberOfItems !== 0"
            :offset-y="10"
            :offset-x="10"
            color="primary"
            class="ml-auto"
            :content="numberOfItems"
            v-bind="$attrs"
        >
            <v-btn color="on-background" :icon="icon"></v-btn>
        </v-badge>
        <v-btn
            v-else
            color="on-background"
            :icon="icon"
            v-bind="$attrs"
        ></v-btn>
    </template>
</template>
